# 웹프로그램 통신

# 모든 웹프로그램은 사용자가 웹 브라우저를 이용해서 웹프로그램이 가지고 있는
# 자원(상품 정보, 강좌 목록(동영상)...)을  요청하면 웹브라우저가 이해할 수있는
# 형태로 재가공 하거나, 있는 자원 그대로 웹브라우저에게 반환해준다.

# 웹서버와 웹브라우저간에 발생하는 자원 반환 단계에서는 웹서버가 콘텐츠 협상(contents negitiation)
# 이라는 단계를 거친 후에 웹브라우저에 결과를 반환한다.
# 이 단계는 웹브라우저가 무엇을 처리할 수 있는지 웹서버와 협상하는 단계

# 이단계는 3가지로 분류할 수 있다.

# 1. 서버 기반의 협상
# 2. 에이전트 기반의 협상
# 3. 투명한 협상(1,2를 혼합한 협상)

# 서버기반 협상 : 웹서버가 웹브라우저에 반환할 데이터의 형태를 직접 결정
# 에이전트(캐시서버) 기반의 협상 : 웹 서버가 응답할 데이터 처리 형태를 결정하기 위해 첫 번째
#                                                   수신을 처리한 에이전트에 의해 형태를 결정


## 협상에 필요한 HTTP 메시지 헤더
# Accept : 브라우저가 처리할 수 있는 데이터의 형태, 선호도
#               text/html
# Accept-Language: 브라우저가 수용할 수 있는 응답결과의 언어와 선호도
# Accept_Encoding : 브라우저가 수용할 수 있는 응답 인코딩 형태와 선호도


# HTTP 메시지는 요청(Request)메시지와 응답(Response)메시지로 나눈다.

# HTTP 요청 메시지 : 메서드(GET, POST), HTTP버전(HTTP/1.1), 호스트명
#                              웹브라우저가 무엇인지(User_Agent헤더), 어떤 언어(ko_KR, ko; en-US)/자원
#                              형태 를 받아들이는지 기록

# HTTP 응답 메시지 : 첫행에는 HTTP 버전, HTTP 상태코드(200:성공), 상태코드 문자열 OK
#                               두번째 행부터는 순서 없이 정보를 기술한다. 날짜, 서버의 종류, 사용자 정의 헤더도
#                               포함된다. X-시작하는 헤더명은 사용자 정의 헤더라고 본다.(사용자 정의 헤더는 웹프로그램과
#                               웹브라우저가 해석할 수 있을 때 의미있는 정보가 된다.)



 
